const char *fallbackShader_generic_vp =
"attribute vec3 attr_Position;\n"
"attribute vec3 attr_Normal;\n"
"\n"
"#if defined(USE_VERTEX_ANIMATION)\n"
"attribute vec3 attr_Position2;\n"
"attribute vec3 attr_Normal2;\n"
"#elif defined(USE_BONE_ANIMATION)\n"
"attribute vec4 attr_BoneIndexes;\n"
"attribute vec4 attr_BoneWeights;\n"
"#endif\n"
"\n"
"attribute vec4 attr_Color;\n"
"attribute vec4 attr_TexCoord0;\n"
"\n"
"#if defined(USE_TCGEN)\n"
"attribute vec4 attr_TexCoord1;\n"
"#endif\n"
"\n"
"#if defined(USE_TCMOD)\n"
"uniform vec4   u_DiffuseTexMatrix0;\n"
"uniform vec4   u_DiffuseTexMatrix1;\n"
"uniform vec4   u_DiffuseTexMatrix2;\n"
"uniform vec4   u_DiffuseTexMatrix3;\n"
"uniform vec4   u_DiffuseTexMatrix4;\n"
"uniform vec4   u_DiffuseTexMatrix5;\n"
"uniform vec4   u_DiffuseTexMatrix6;\n"
"uniform vec4   u_DiffuseTexMatrix7;\n"
"#endif\n"
"\n"
"#if defined(USE_TCGEN) || defined(USE_RGBAGEN)\n"
"uniform vec3   u_LocalViewOrigin;\n"
"#endif\n"
"\n"
"#if defined(USE_TCGEN)\n"
"uniform int    u_TCGen0;\n"
"uniform vec3   u_TCGen0Vector0;\n"
"uniform vec3   u_TCGen0Vector1;\n"
"#endif\n"
"\n"
"#if defined(USE_FOG)\n"
"uniform vec4   u_FogDistance;\n"
"uniform vec4   u_FogDepth;\n"
"uniform float  u_FogEyeT;\n"
"uniform vec4   u_FogColorMask;\n"
"#endif\n"
"\n"
"#if defined(USE_DEFORM_VERTEXES)\n"
"uniform int    u_DeformGen;\n"
"uniform float  u_DeformParams[5];\n"
"uniform float  u_Time;\n"
"#endif\n"
"\n"
"uniform mat4   u_ModelViewProjectionMatrix;\n"
"uniform vec4   u_BaseColor;\n"
"uniform vec4   u_VertColor;\n"
"\n"
"#if defined(USE_RGBAGEN)\n"
"uniform int    u_ColorGen;\n"
"uniform int    u_AlphaGen;\n"
"uniform vec3   u_AmbientLight;\n"
"uniform vec3   u_DirectedLight;\n"
"uniform vec3   u_ModelLightDir;\n"
"uniform float  u_PortalRange;\n"
"#endif\n"
"\n"
"#if defined(USE_VERTEX_ANIMATION)\n"
"uniform float  u_VertexLerp;\n"
"#elif defined(USE_BONE_ANIMATION)\n"
"uniform mat4 u_BoneMatrix[MAX_GLSL_BONES];\n"
"#endif\n"
"\n"
"varying vec2   var_DiffuseTex;\n"
"varying vec4   var_Color;\n"
"\n"
"#if defined(USE_DEFORM_VERTEXES)\n"
"vec3 DeformPosition(const vec3 pos, const vec3 normal, const vec2 st)\n"
"{\n"
"	float base =      u_DeformParams[0];\n"
"	float amplitude = u_DeformParams[1];\n"
"	float phase =     u_DeformParams[2];\n"
"	float frequency = u_DeformParams[3];\n"
"	float spread =    u_DeformParams[4];\n"
"\n"
"	if (u_DeformGen == DGEN_BULGE)\n"
"	{\n"
"		phase *= st.x;\n"
"	}\n"
"	else // if (u_DeformGen <= DGEN_WAVE_INVERSE_SAWTOOTH)\n"
"	{\n"
"		phase += dot(pos.xyz, vec3(spread));\n"
"	}\n"
"\n"
"	float value = phase + (u_Time * frequency);\n"
"	float func;\n"
"\n"
"	if (u_DeformGen == DGEN_WAVE_SIN)\n"
"	{\n"
"		func = sin(value * 2.0 * M_PI);\n"
"	}\n"
"	else if (u_DeformGen == DGEN_WAVE_SQUARE)\n"
"	{\n"
"		func = sign(fract(0.5 - value));\n"
"	}\n"
"	else if (u_DeformGen == DGEN_WAVE_TRIANGLE)\n"
"	{\n"
"		func = abs(fract(value + 0.75) - 0.5) * 4.0 - 1.0;\n"
"	}\n"
"	else if (u_DeformGen == DGEN_WAVE_SAWTOOTH)\n"
"	{\n"
"		func = fract(value);\n"
"	}\n"
"	else if (u_DeformGen == DGEN_WAVE_INVERSE_SAWTOOTH)\n"
"	{\n"
"		func = (1.0 - fract(value));\n"
"	}\n"
"	else // if (u_DeformGen == DGEN_BULGE)\n"
"	{\n"
"		func = sin(value);\n"
"	}\n"
"\n"
"	return pos + normal * (base + func * amplitude);\n"
"}\n"
"#endif\n"
"\n"
"#if defined(USE_TCGEN)\n"
"vec2 GenTexCoords(int TCGen, vec3 position, vec3 normal, vec3 TCGenVector0, vec3 TCGenVector1)\n"
"{\n"
"	vec2 tex = attr_TexCoord0.st;\n"
"\n"
"	if (TCGen == TCGEN_LIGHTMAP)\n"
"	{\n"
"		tex = attr_TexCoord1.st;\n"
"	}\n"
"	else if (TCGen == TCGEN_ENVIRONMENT_MAPPED)\n"
"	{\n"
"		vec3 viewer = normalize(u_LocalViewOrigin - position);\n"
"		vec2 ref = reflect(viewer, normal).yz;\n"
"		tex.s = ref.x * -0.5 + 0.5;\n"
"		tex.t = ref.y *  0.5 + 0.5;\n"
"	}\n"
"	else if (TCGen == TCGEN_VECTOR)\n"
"	{\n"
"		tex = vec2(dot(position, TCGenVector0), dot(position, TCGenVector1));\n"
"	}\n"
"\n"
"	return tex;\n"
"}\n"
"#endif\n"
"\n"
"#if defined(USE_TCMOD)\n"
"vec2 ModTexCoords(vec2 st, vec3 position, vec4 texMatrix[8])\n"
"{\n"
"	vec2 st2 = st;\n"
"	vec2 offsetPos = vec2(position.x + position.z, position.y);\n"
"\n"
"	st2 = vec2(st2.x * texMatrix[0].x + st2.y * texMatrix[0].y + texMatrix[0].z,\n"
"	           st2.x * texMatrix[1].x + st2.y * texMatrix[1].y + texMatrix[1].z);\n"
"	st2 += texMatrix[0].w * sin(offsetPos * (2.0 * M_PI / 1024.0) + vec2(texMatrix[1].w * 2.0 * M_PI));\n"
"\n"
"	st2 = vec2(st2.x * texMatrix[2].x + st2.y * texMatrix[2].y + texMatrix[2].z,\n"
"	           st2.x * texMatrix[3].x + st2.y * texMatrix[3].y + texMatrix[3].z);\n"
"	st2 += texMatrix[2].w * sin(offsetPos * (2.0 * M_PI / 1024.0) + vec2(texMatrix[3].w * 2.0 * M_PI));\n"
"\n"
"	st2 = vec2(st2.x * texMatrix[4].x + st2.y * texMatrix[4].y + texMatrix[4].z,\n"
"	           st2.x * texMatrix[5].x + st2.y * texMatrix[5].y + texMatrix[5].z);\n"
"	st2 += texMatrix[4].w * sin(offsetPos * (2.0 * M_PI / 1024.0) + vec2(texMatrix[5].w * 2.0 * M_PI));\n"
"\n"
"	st2 = vec2(st2.x * texMatrix[6].x + st2.y * texMatrix[6].y + texMatrix[6].z,\n"
"	           st2.x * texMatrix[7].x + st2.y * texMatrix[7].y + texMatrix[7].z);\n"
"	st2 += texMatrix[6].w * sin(offsetPos * (2.0 * M_PI / 1024.0) + vec2(texMatrix[7].w * 2.0 * M_PI));\n"
"\n"
"	return st2;\n"
"}\n"
"#endif\n"
"\n"
"#if defined(USE_RGBAGEN)\n"
"vec4 CalcColor(vec3 position, vec3 normal)\n"
"{\n"
"	vec4 color = u_VertColor * attr_Color + u_BaseColor;\n"
"\n"
"	if (u_ColorGen == CGEN_LIGHTING_DIFFUSE)\n"
"	{\n"
"		float incoming = clamp(dot(normal, u_ModelLightDir), 0.0, 1.0);\n"
"\n"
"		color.rgb = clamp(u_DirectedLight * incoming + u_AmbientLight, 0.0, 1.0);\n"
"	}\n"
"\n"
"	vec3 viewer = u_LocalViewOrigin - position;\n"
"\n"
"	if (u_AlphaGen == AGEN_LIGHTING_SPECULAR)\n"
"	{\n"
"		vec3 lightDir = normalize(vec3(-960.0, 1980.0, 96.0) - position);\n"
"		vec3 reflected = -reflect(lightDir, normal);\n"
"\n"
"		color.a = clamp(dot(reflected, normalize(viewer)), 0.0, 1.0);\n"
"		color.a *= color.a;\n"
"		color.a *= color.a;\n"
"	}\n"
"	else if (u_AlphaGen == AGEN_PORTAL)\n"
"	{\n"
"		color.a = clamp(length(viewer) / u_PortalRange, 0.0, 1.0);\n"
"	}\n"
"\n"
"	return color;\n"
"}\n"
"#endif\n"
"\n"
"#if defined(USE_FOG)\n"
"float CalcFog(vec3 position)\n"
"{\n"
"	float s = dot(vec4(position, 1.0), u_FogDistance) * 8.0;\n"
"	float t = dot(vec4(position, 1.0), u_FogDepth);\n"
"\n"
"	float eyeOutside = float(u_FogEyeT < 0.0);\n"
"	float fogged = float(t >= eyeOutside);\n"
"\n"
"	t += 1e-6;\n"
"	t *= fogged / (t - u_FogEyeT * eyeOutside);\n"
"\n"
"	return s * t;\n"
"}\n"
"#endif\n"
"\n"
"void main()\n"
"{\n"
"#if defined(USE_VERTEX_ANIMATION)\n"
"	vec3 position  = mix(attr_Position, attr_Position2, u_VertexLerp);\n"
"	vec3 normal    = mix(attr_Normal,   attr_Normal2,   u_VertexLerp);\n"
"#elif defined(USE_BONE_ANIMATION)\n"
"	mat4 vtxMat  = u_BoneMatrix[int(attr_BoneIndexes.x)] * attr_BoneWeights.x;\n"
"	     vtxMat += u_BoneMatrix[int(attr_BoneIndexes.y)] * attr_BoneWeights.y;\n"
"	     vtxMat += u_BoneMatrix[int(attr_BoneIndexes.z)] * attr_BoneWeights.z;\n"
"	     vtxMat += u_BoneMatrix[int(attr_BoneIndexes.w)] * attr_BoneWeights.w;\n"
"	mat3 nrmMat = mat3(cross(vtxMat[1].xyz, vtxMat[2].xyz), cross(vtxMat[2].xyz, vtxMat[0].xyz), cross(vtxMat[0].xyz, vtxMat[1].xyz));\n"
"\n"
"	vec3 position  = vec3(vtxMat * vec4(attr_Position, 1.0));\n"
"	vec3 normal    = normalize(nrmMat * attr_Normal);\n"
"#else\n"
"	vec3 position  = attr_Position;\n"
"	vec3 normal    = attr_Normal;\n"
"#endif\n"
"\n"
"#if defined(USE_DEFORM_VERTEXES)\n"
"	position = DeformPosition(position, normal, attr_TexCoord0.st);\n"
"#endif\n"
"\n"
"	gl_Position = u_ModelViewProjectionMatrix * vec4(position, 1.0);\n"
"\n"
"#if defined(USE_TCGEN)\n"
"	vec2 tex = GenTexCoords(u_TCGen0, position, normal, u_TCGen0Vector0, u_TCGen0Vector1);\n"
"#else\n"
"	vec2 tex = attr_TexCoord0.st;\n"
"#endif\n"
"\n"
"#if defined(USE_TCMOD)\n"
"	vec4 diffuseTexMatrix[8];\n"
"	diffuseTexMatrix[0] = u_DiffuseTexMatrix0;\n"
"	diffuseTexMatrix[1] = u_DiffuseTexMatrix1;\n"
"	diffuseTexMatrix[2] = u_DiffuseTexMatrix2;\n"
"	diffuseTexMatrix[3] = u_DiffuseTexMatrix3;\n"
"	diffuseTexMatrix[4] = u_DiffuseTexMatrix4;\n"
"	diffuseTexMatrix[5] = u_DiffuseTexMatrix5;\n"
"	diffuseTexMatrix[6] = u_DiffuseTexMatrix6;\n"
"	diffuseTexMatrix[7] = u_DiffuseTexMatrix7;\n"
"	var_DiffuseTex = ModTexCoords(tex, position, diffuseTexMatrix);\n"
"#else\n"
"    var_DiffuseTex = tex;\n"
"#endif\n"
"\n"
"#if defined(USE_RGBAGEN)\n"
"	var_Color = CalcColor(position, normal);\n"
"#else\n"
"	var_Color = u_VertColor * attr_Color + u_BaseColor;\n"
"#endif\n"
"\n"
"#if defined(USE_FOG)\n"
"	var_Color *= vec4(1.0) - u_FogColorMask * sqrt(clamp(CalcFog(position), 0.0, 1.0));\n"
"#endif\n"
"}\n"
;
