const char *fallbackShader_pshadow_fp =
"uniform sampler2D u_ShadowMap;\n"
"\n"
"uniform vec3      u_LightForward;\n"
"uniform vec3      u_LightUp;\n"
"uniform vec3      u_LightRight;\n"
"uniform vec4      u_LightOrigin;\n"
"uniform float     u_LightRadius;\n"
"varying vec3      var_Position;\n"
"varying vec3      var_Normal;\n"
"\n"
"void main()\n"
"{\n"
"	vec3 lightToPos = var_Position - u_LightOrigin.xyz;\n"
"	vec2 st = vec2(-dot(u_LightRight, lightToPos), dot(u_LightUp, lightToPos));\n"
"\n"
"	float fade = length(st);\n"
"\n"
"#if defined(USE_DISCARD)\n"
"	if (fade >= 1.0)\n"
"	{\n"
"		discard;\n"
"	}\n"
"#endif\n"
"\n"
"	fade = clamp(8.0 - fade * 8.0, 0.0, 1.0);\n"
"\n"
"	st = st * 0.5 + vec2(0.5);\n"
"\n"
"#if defined(USE_SOLID_PSHADOWS)\n"
"	float intensity = max(sign(u_LightRadius - length(lightToPos)), 0.0);\n"
"#else\n"
"	float intensity = clamp((1.0 - dot(lightToPos, lightToPos) / (u_LightRadius * u_LightRadius)) * 2.0, 0.0, 1.0);\n"
"#endif\n"
"\n"
"	float lightDist = length(lightToPos);\n"
"	float dist;\n"
"\n"
"#if defined(USE_DISCARD)\n"
"	if (dot(u_LightForward, lightToPos) <= 0.0)\n"
"	{\n"
"		discard;\n"
"	}\n"
"\n"
"	if (dot(var_Normal, lightToPos) > 0.0)\n"
"	{\n"
"		discard;\n"
"	}\n"
"#else\n"
"	intensity *= max(sign(dot(u_LightForward, lightToPos)), 0.0);\n"
"	intensity *= max(sign(-dot(var_Normal, lightToPos)), 0.0);\n"
"#endif\n"
"\n"
"	intensity *= fade;\n"
"\n"
"	float part;\n"
"#if defined(USE_PCF)\n"
"	part  = float(texture2D(u_ShadowMap, st + vec2(-1.0/512.0, -1.0/512.0)).r != 1.0);\n"
"	part += float(texture2D(u_ShadowMap, st + vec2( 1.0/512.0, -1.0/512.0)).r != 1.0);\n"
"	part += float(texture2D(u_ShadowMap, st + vec2(-1.0/512.0,  1.0/512.0)).r != 1.0);\n"
"	part += float(texture2D(u_ShadowMap, st + vec2( 1.0/512.0,  1.0/512.0)).r != 1.0);\n"
"#else\n"
"	part  = float(texture2D(u_ShadowMap, st).r != 1.0);\n"
"#endif\n"
"\n"
"	if (part <= 0.0)\n"
"	{\n"
"		discard;\n"
"	}\n"
"\n"
"#if defined(USE_PCF)\n"
"	intensity *= part * 0.25;\n"
"#else\n"
"	intensity *= part;\n"
"#endif\n"
"\n"
"	gl_FragColor.rgb = vec3(0);\n"
"	gl_FragColor.a = clamp(intensity, 0.0, 0.75);\n"
"}\n"
;
