const char *fallbackShader_shadowfill_vp =
"attribute vec3  attr_Position;\n"
"attribute vec3  attr_Normal;\n"
"attribute vec4  attr_TexCoord0;\n"
"\n"
"#if defined(USE_VERTEX_ANIMATION)\n"
"attribute vec3  attr_Position2;\n"
"attribute vec3  attr_Normal2;\n"
"#elif defined(USE_BONE_ANIMATION)\n"
"attribute vec4 attr_BoneIndexes;\n"
"attribute vec4 attr_BoneWeights;\n"
"#endif\n"
"\n"
"//#if defined(USE_DEFORM_VERTEXES)\n"
"uniform int     u_DeformGen;\n"
"uniform float    u_DeformParams[5];\n"
"//#endif\n"
"\n"
"uniform float   u_Time;\n"
"uniform mat4    u_ModelViewProjectionMatrix;\n"
"\n"
"uniform mat4   u_ModelMatrix;\n"
"\n"
"#if defined(USE_VERTEX_ANIMATION)\n"
"uniform float   u_VertexLerp;\n"
"#elif defined(USE_BONE_ANIMATION)\n"
"uniform mat4 u_BoneMatrix[MAX_GLSL_BONES];\n"
"#endif\n"
"\n"
"varying vec3    var_Position;\n"
"\n"
"vec3 DeformPosition(const vec3 pos, const vec3 normal, const vec2 st)\n"
"{\n"
"	if (u_DeformGen == 0)\n"
"	{\n"
"		return pos;\n"
"	}\n"
"\n"
"	float base =      u_DeformParams[0];\n"
"	float amplitude = u_DeformParams[1];\n"
"	float phase =     u_DeformParams[2];\n"
"	float frequency = u_DeformParams[3];\n"
"	float spread =    u_DeformParams[4];\n"
"\n"
"	if (u_DeformGen == DGEN_BULGE)\n"
"	{\n"
"		phase *= st.x;\n"
"	}\n"
"	else // if (u_DeformGen <= DGEN_WAVE_INVERSE_SAWTOOTH)\n"
"	{\n"
"		phase += dot(pos.xyz, vec3(spread));\n"
"	}\n"
"\n"
"	float value = phase + (u_Time * frequency);\n"
"	float func;\n"
"\n"
"	if (u_DeformGen == DGEN_WAVE_SIN)\n"
"	{\n"
"		func = sin(value * 2.0 * M_PI);\n"
"	}\n"
"	else if (u_DeformGen == DGEN_WAVE_SQUARE)\n"
"	{\n"
"		func = sign(0.5 - fract(value));\n"
"	}\n"
"	else if (u_DeformGen == DGEN_WAVE_TRIANGLE)\n"
"	{\n"
"		func = abs(fract(value + 0.75) - 0.5) * 4.0 - 1.0;\n"
"	}\n"
"	else if (u_DeformGen == DGEN_WAVE_SAWTOOTH)\n"
"	{\n"
"		func = fract(value);\n"
"	}\n"
"	else if (u_DeformGen == DGEN_WAVE_INVERSE_SAWTOOTH)\n"
"	{\n"
"		func = (1.0 - fract(value));\n"
"	}\n"
"	else // if (u_DeformGen == DGEN_BULGE)\n"
"	{\n"
"		func = sin(value);\n"
"	}\n"
"\n"
"	return pos + normal * (base + func * amplitude);\n"
"}\n"
"\n"
"void main()\n"
"{\n"
"#if defined(USE_VERTEX_ANIMATION)\n"
"	vec3 position  = mix(attr_Position, attr_Position2, u_VertexLerp);\n"
"	vec3 normal    = mix(attr_Normal,   attr_Normal2,   u_VertexLerp);\n"
"#elif defined(USE_BONE_ANIMATION)\n"
"	mat4 vtxMat  = u_BoneMatrix[int(attr_BoneIndexes.x)] * attr_BoneWeights.x;\n"
"	     vtxMat += u_BoneMatrix[int(attr_BoneIndexes.y)] * attr_BoneWeights.y;\n"
"	     vtxMat += u_BoneMatrix[int(attr_BoneIndexes.z)] * attr_BoneWeights.z;\n"
"	     vtxMat += u_BoneMatrix[int(attr_BoneIndexes.w)] * attr_BoneWeights.w;\n"
"	mat3 nrmMat = mat3(cross(vtxMat[1].xyz, vtxMat[2].xyz), cross(vtxMat[2].xyz, vtxMat[0].xyz), cross(vtxMat[0].xyz, vtxMat[1].xyz));\n"
"\n"
"	vec3 position  = vec3(vtxMat * vec4(attr_Position, 1.0));\n"
"	vec3 normal    = normalize(nrmMat * attr_Normal);\n"
"#else\n"
"	vec3 position = attr_Position;\n"
"	vec3 normal   = attr_Normal;\n"
"#endif\n"
"\n"
"	position = DeformPosition(position, normal, attr_TexCoord0.st);\n"
"\n"
"	gl_Position = u_ModelViewProjectionMatrix * vec4(position, 1.0);\n"
"\n"
"	var_Position  = (u_ModelMatrix * vec4(position, 1.0)).xyz;\n"
"}\n"
;
