const char *fallbackShader_tonemap_fp =
"uniform sampler2D u_TextureMap;\n"
"uniform sampler2D u_LevelsMap;\n"
"\n"
"uniform vec4      u_Color;\n"
"\n"
"\n"
"uniform vec2      u_AutoExposureMinMax;\n"
"uniform vec3      u_ToneMinAvgMaxLinear;\n"
"\n"
"varying vec2      var_TexCoords;\n"
"varying float     var_InvWhite;\n"
"\n"
"const vec3  LUMINANCE_VECTOR =   vec3(0.2125, 0.7154, 0.0721); //vec3(0.299, 0.587, 0.114);\n"
"\n"
"float FilmicTonemap(float x)\n"
"{\n"
"	const float SS  = 0.22; // Shoulder Strength\n"
"	const float LS  = 0.30; // Linear Strength\n"
"	const float LA  = 0.10; // Linear Angle\n"
"	const float TS  = 0.20; // Toe Strength\n"
"	const float TAN = 0.01; // Toe Angle Numerator\n"
"	const float TAD = 0.30; // Toe Angle Denominator\n"
"\n"
"	return ((x*(SS*x+LA*LS)+TS*TAN)/(x*(SS*x+LS)+TS*TAD)) - TAN/TAD;\n"
"}\n"
"\n"
"void main()\n"
"{\n"
"	vec4 color = texture2D(u_TextureMap, var_TexCoords) * u_Color;\n"
"\n"
"#if defined(USE_PBR)\n"
"	color.rgb *= color.rgb;\n"
"#endif\n"
"\n"
"	vec3 minAvgMax = texture2D(u_LevelsMap, var_TexCoords).rgb;\n"
"	vec3 logMinAvgMaxLum = clamp(minAvgMax * 20.0 - 10.0, -u_AutoExposureMinMax.y, -u_AutoExposureMinMax.x);\n"
"\n"
"	float invAvgLum = u_ToneMinAvgMaxLinear.y * exp2(-logMinAvgMaxLum.y);\n"
"\n"
"	color.rgb = color.rgb * invAvgLum - u_ToneMinAvgMaxLinear.xxx;\n"
"	color.rgb = max(vec3(0.0), color.rgb);\n"
"\n"
"	color.r = FilmicTonemap(color.r);\n"
"	color.g = FilmicTonemap(color.g);\n"
"	color.b = FilmicTonemap(color.b);\n"
"\n"
"	color.rgb = clamp(color.rgb * var_InvWhite, 0.0, 1.0);\n"
"\n"
"#if defined(USE_PBR)\n"
"	color.rgb = sqrt(color.rgb);\n"
"#endif\n"
"\n"
"	// add a bit of dither to reduce banding\n"
"	color.rgb += vec3(1.0/510.0 * mod(gl_FragCoord.x + gl_FragCoord.y, 2.0) - 1.0/1020.0);\n"
"\n"
"	gl_FragColor = color;\n"
"}\n"
;
